require "enet"
require "stc"
local UUID = require "UUID"

local host = enet.host_create("*:12345")
local event = host:service()
local tableReceive
local playerTable = {}
local userTable = {}
local dataSendTimer = .05

local test1 = false
local test2 = false
local stringTest = ""
local stringTest2 = ""

function connect(event)
	if event and event.type == "receive" then
		if event.data:match("^(%S*)") == "startup" then
			local currentUser = table.getn(userTable) + 1
			local currentPlayer = table.getn(playerTable) + 1
			userTable[currentUser] = {}
			userTable[currentUser].id = UUID()
			userTable[currentUser].player = currentPlayer
			userTable[currentUser].w = false
			userTable[currentUser].s = false
			userTable[currentUser].a = false
			userTable[currentUser].d = false
			playerTable[currentPlayer] = {}
			playerTable[currentPlayer][1] = 100
			playerTable[currentPlayer][2] = 100
			playerTable[currentPlayer][3] = userTable[currentUser].id
			playerTable[currentPlayer][4] = currentUser
			userTable[currentUser].peer = event.peer
			userTable[currentUser].peer:send("started" .. " " .. userTable[currentUser].id)
		end
	end
end

function takeInputs(event)
	if event and event.type == "receive" then
		if event.data:match("^(%S*)") == "inputsend" then
		--matches ID of user with userTable
		local idCheck = event.data:match("^%S* (%S*)")
		stringTest2 = idCheck
		test1 = true
			for i = 1, table.getn(userTable) do
				if userTable[i].id == idCheck then
					--messy, but how else would you do this?  lua regex sucks
					--uses local operators to derive booleans from strings
					userTable[i].w = ((event.data:match("^%S* %S* (%S*)")) == "true")
					userTable[i].s = ((event.data:match("^%S* %S* %S* (%S*)")) == "true")
					userTable[i].a = ((event.data:match("^%S* %S* %S* %S* (%S*)")) == "true")
					userTable[i].d = ((event.data:match("^%S* %S* %S* %S* %S* (%S*)")) == "true")
					
					stringTest = (event.data:match("^%S* %S* (%S*)"))
				end
			end
		end
	end
end

function sendData()
	for i = 1, table.getn(userTable) do
		userTable[i].peer:send("playertable" .. " " .. stcstring(playerTable))
	end
end

function updatePlayers(dt)
	for i = 1, table.getn(playerTable) do
		local self = playerTable[i]
		if userTable[self[4]].w == true then
			self[2] = self[2] - (50 * dt)
		end
		
		if userTable[self[4]].s == true then
			self[2] = self[2] + (50 * dt)
		end
		
		if userTable[self[4]].a == true then
			self[1] = self[1] - (50 * dt)
		end
		
		if userTable[self[4]].d == true then
			self[1] = self[1] + (50 * dt)
		end
	end
end

function love.update(dt)
	local event = host:service()
	connect(event)
	takeInputs(event)
	
	updatePlayers(dt)
	
	dataSendTimer = dataSendTimer - dt
	
	if dataSendTimer <= 0 then
		sendData()
		dataSendTimer = .05
	end
	--[[if event and event.type == "receive" then
		tableReceive = stctable(event.data)
		for i = 1, table.getn(tableReceive) do
			for j = 1, table.getn(tableReceive[i]) do
				tableReceive[i][j] = tableReceive[i][j] * 2
			end
		end
		event.peer:send(stcstring(tableReceive))
	end
	--host:service()]]
end

function love.draw()
	if userTable[1] then
		love.graphics.print(tostring(userTable[1].w), 10, 10)
		love.graphics.print(tostring(userTable[1].id), 10, 90)
	end
	love.graphics.print(tostring(stringTest), 10, 30)
	love.graphics.print(tostring(test1), 10, 50)
	love.graphics.print(tostring(stringTest2), 10, 70)
end